
var md5 = require("md5");
var mta = require("mta");
var sdk_conf = require("sdk_conf");
var sdk = require("sdk");

var adSdk = {


    BannerAd: null,

    VideoAd: null,
    videoAd1: null,
    videoAd2: null,
    videoAd3: null,

    //视频成功回调 
    videoSuccess: null,
    //视频失败回调 
    videoFail: null,
    videoError: null,
    
     /**
     * @param {int} index 视频id的数字编号 1 2 3 
     * @param {string} videoAdUnitId
     * 
     *adSdk.videoSuccess = function(){
     *      //视频成功处理逻辑
     *      this.successFunction();
     * };
     * adSdk.videoFail = function(){
     *      //视频失败处理逻辑
     *      this.failFunction();`
     * };
     * adSdk.videoError = function(){
     *      //视频失败处理逻辑
     *      this.errorFunction();`
     * };
     * var videoAd = adSdk.createRewardedVideoAd(1,videoAdUnitId);
     * videoAd.load().then(() => videoAd.show());
     * 
     */
    createVideoAd(index, videoAdUnitId) {
        if (index == 1) {
            if (this.VideoAd1) {
                return this.VideoAd1;
            }
        } else if (index == 2) {
            if (this.VideoAd2) {
                return this.VideoAd2;
            }

        } else if (index == 3) {
            if (this.VideoAd3) {
                return this.VideoAd3;
            }
        }
        else {
            if (this.VideoAd) {
                return this.VideoAd;
            }
        }
        return adSdk.createRewardedVideoAd(index, videoAdUnitId);
    },



     /**
     * 
     * @param {json} obj 
     * @param {string} bannerAdUnitId 
     * 多个banner广告id调用如下：
     * adSdk.createBannerAdByAdId({},bannerAdUnitId).destroy();
     *       adSdk.BannerAd =null;
     *       var bannerAd =adSdk.createBannerAdByAdId({},bannerAdUnitId2);
     *       bannerAd.show(); 
     * 
     */

    createBannerAdByAdId(obj,bannerAdUnitId){
        var self = this;
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            if(this.BannerAd){
                return this.BannerAd;
            }else{
                if(!obj.style){
                    obj.style = {};
                    var phone = wx.getSystemInfoSync();
                    this.w = phone.screenWidth / 2;
                    this.h = phone.screenHeight;
                    obj.style.left = 0;
                    obj.style.top = 0;
                    obj.style.width = 300;
                }
                this.BannerAd = wx.createBannerAd({
                    adUnitId: bannerAdUnitId,
                    style: obj.style,
                })
                this.BannerAd.onResize(function(res){
                    console.log("sdk BannerAd广告缩放事件：", res)
                    self.BannerAd.style.left = self.w - self.BannerAd.style.realWidth/2+0.1;
                    self.BannerAd.style.top = self.h - self.BannerAd.style.realHeight+0.1;
                });
                this.BannerAd.onLoad(function(res){
                    console.log("sdk BannerAd广告加载事件：", res)
                });
                this.BannerAd.onError(function(res){
                    console.log("sdk BannerAd广告错误事件：", res)
                });

                return this.BannerAd;
            }
        }
    },


    /**
     * 后期会慢慢弃用，因为该方法只适合一个banner广告的情况
     * @param {json} obj 
     * var bannerAd =adSdk.createBannerAd({},bannerAdUnitId);
     * bannerAd.show(); 
     * 
     */
    createBannerAd(obj){
       
        return sdk.createBannerAd(obj);
    },


    /**
     * 该方法不直接对外提供调用
     * @param {int} index 
     * @param {string} videoAdUnitId1 
     * 
     */
    createRewardedVideoAd(index, videoAdUnitId1) {
        let self = this;
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            let videoAd = wx.createRewardedVideoAd({ adUnitId: videoAdUnitId1 })
            videoAd.onLoad(function (res) {
                console.log("sdk VideoAd广告加载事件：", res)
            });

            var closeFun1 = function (res) {
                // 用户点击了【关闭广告】按钮
                // 小于 2.1.0 的基础库版本，res 是一个 undefined
                if (res && res.isEnded || res === undefined) {
                    console.log("sdk 看视频成功");
                    self.videoSuccess();
                } else {
                    console.error("sdk 看视频失败");
                    self.videoFail();
                }
            };


            videoAd.onClose(closeFun1);

            videoAd.onError(function (res) {
                if (self.videoError) {
                    self.videoError();
                }
            });

            if (index == 1) {
                this.videoAd1 = videoAd;
            }
            else if (index == 2) {
                this.videoAd2 = videoAd;
            }
            else if (index == 3) {
                this.videoAd3 = videoAd;
            }
            else {
                this.VideoAd = videoAd;
            }
            return videoAd;
        }
    }
	
};

window.adSdk = adSdk;
